clear; clc;
analysistitle = 'all12mmdata';
scratchdatfiles = {...
    'run797-cell4',...
    'run797-trycell4-6p26',...
    'run794-cell7',...
    'run797-cell3'};

cdir = cd;
savefilename = [cdir '\' analysistitle];
nall = length(scratchdatfiles);
AllTracks = {};
inorexclude = {[1 1],[1],[1 0 ],[1 0 1]};
% save(savefilename);

isloaded = 0;
% load(savefilename);

%% read data
if ~isloaded,
    isfitted = 0;
    ntrackstot = 0;
    for i = 1:nall,
        filename = [scratchdatfiles{i} '.scratch']
        in = fopen(filename,'rt');
        headline = fgets(in);
        [ntracks,rem] = strtok(headline);ntracks = str2num(ntracks);
        [nfiles,rem] = strtok(rem);nfiles = str2num(nfiles);
        radpos = []; fscanstring = '';
        for t=1:ntracks,fscanstring = [fscanstring, '%g %g '];[r,rem] = strtok(rem);r = str2num(r);radpos = [radpos r];end;
        data = fscanf(in,fscanstring,[2*ntracks nfiles]);
        fclose(in);
        slopes = [ ]; shifts = [ ];
        for t=1:ntracks,slopes = [slopes; data(1+(t-1)*2,:)];shifts = [shifts; data(2+(t-1)*2,:)];end; slopes = slopes'; shifts = shifts';
        TrackData = struct('filename',filename,'ntracks',ntracks,'npoints',nfiles,'radii',radpos,'slopes',slopes,'shifts',shifts,'slopefitmin',zeros(1,ntracks));
        AllTracks{i} = TrackData;
        ntrackstot = ntrackstot + ntracks;
    end;
    CC = linspecer(ntrackstot);
end;

%% plot 1 by 1
% hsel = figure(1); clf; hold off;
% inorexclude = {};
% for n=1:nall,
%     inorexclude{n} = ones(1,AllTracks{n}.ntracks);
%     for t=1:AllTracks{n}.ntracks,
%         plot(AllTracks{n}.slopes(:,t),AllTracks{n}.shifts(:,t),'x-','LineWidth',1,'Color',CC(countt,:));
%         titlestr = [AllTracks{n}.filename '-' num2str(t) '@' num2str(AllTracks{n}.radii(t))];
%         title(titlestr);
%         if 'n' == input('include (y/n)?','s'),
%             inorexclude{n}(t) = 0;
%         end;
%
%     end;
% end;
% delete(hsel);
for n=1:nall, disp(inorexclude{n});end;

%% enter threshold for analysis with mouse
if ~isloaded,
    hsel = figure(1); clf; hold off; countt = 0;
    for n=1:nall,
        for t=1:AllTracks{n}.ntracks, if inorexclude{n}(t),
                countt = countt + 1;
                plot(AllTracks{n}.slopes(:,t),AllTracks{n}.shifts(:,t),'x-','LineWidth',1,'Color',CC(countt,:));
                titlestr = ['CLICK ON MIN SLOPE for ' AllTracks{n}.filename '-' num2str(t) '@' num2str(AllTracks{n}.radii(t))];
                title(titlestr);
                [x,y] = ginput(1);
                AllTracks{n}.slopefitmin(t) = x;
            end;end;
    end;
    delete(hsel);
end;

%%  plot all
hall = figure('Name',analysistitle,'NumberTitle','off'); clf;
set(gcf,'PaperOrientation','portrait');
set(gcf,'PaperPositionMode','manual');
set(gcf,'Units','inches');
set(gcf,'PaperUnits','inches');
set(gcf,'Position',[1 0.5 6.5 4.5]);%on screen, but also on paper?
set(gcf,'PaperPosition', [1 0.5 6.5 4.5]);
%     set(gcf, 'color', 'white'); %this is the background
subplot('Position',[0.15 0.15 0.8 0.75]);hold on;
set(gca,'FontSize',11);
set(gca,'FontName','Times');
set(gca,'Box', 'on');
xborder = 0.05; yborder = 0.02;

hold on;
countt = 0;legendstr = [];
for n=1:nall,
    for t=1:AllTracks{n}.ntracks,
        countt = countt + 1;
        if inorexclude{n}(t),
            filter = AllTracks{n}.slopes(:,t) > AllTracks{n}.slopefitmin(t);
            plot(AllTracks{n}.slopes(:,t),AllTracks{n}.shifts(:,t),'o','LineWidth',0.25,'Color',CC(countt,:));
            %             plot(AllTracks{n}.slopes(filter,t),AllTracks{n}.shifts(filter,t),'o','LineWidth',0.25,'MarkerFaceColor',CC(countt,:));
            legendstr = [legendstr '''' [AllTracks{n}.filename '-' num2str(t) '@' num2str(AllTracks{n}.radii(t))] ''''];
            if countt < ntrackstot, legendstr = [legendstr ', ']; end;
        end;
    end;
end;
YL = ylim; countt = 0;
if isfitted,
    for n=1:nall,
        for t=1:AllTracks{n}.ntracks,
            countt = countt + 1;
            if inorexclude{n}(t),
                plot(fitxpS{n}{t},fitfitD{n}{t},'-','LineWidth',1,'Color',CC(countt,:));
            end;
        end;
    end;
else
    for n=1:nall,
        for t=1:AllTracks{n}.ntracks,
            countt = countt + 1;
            if inorexclude{n}(t),
                plot(AllTracks{n}.slopefitmin(t)*[1 1],0.9*YL,':','LineWidth',0.75,'Color',CC(countt,:));
            end;
        end;
    end;
end;

eval (['hleg = legend (' legendstr ',''Location'',''SouthEast'');']);
set(hleg,'FontSize',6); legend('boxoff');

countt = 0;
for n=1:nall,
    for t=1:AllTracks{n}.ntracks,
        countt = countt + 1;
        if inorexclude{n}(t),
            filter = AllTracks{n}.slopes(:,t) > AllTracks{n}.slopefitmin(t);
            %             plot(AllTracks{n}.slopes(:,t),AllTracks{n}.shifts(:,t),'o','LineWidth',0.25,'Color',CC(countt,:));
            plot(AllTracks{n}.slopes(filter,t),AllTracks{n}.shifts(filter,t),'o','LineWidth',0.25,'MarkerFaceColor',CC(countt,:));
        end;
    end;
end;

if isfitted,
    title(['best-fit shift/slope = ' num2str(fitA)]);
end;
ylabel('displacement (cm)','FontSize',14);
xlabel('signal slope (fringes/cm)','FontSize', 14);
saveas(hall,[cdir '\' analysistitle '.fig']);
print(hall,[cdir '\' analysistitle '.png'],'-dpng','-r300');


%% calculate average slope
if ~isfitted,
    fitxpD = cell(1,nall);fitxpDprime = cell(1,nall); fitxpDbar = cell(1,nall);
    fitxpS = cell(1,nall);fitxpSprime = cell(1,nall); fitxpSbar = cell(1,nall);
    fitNt = cell(1,nall);
    fitbt = cell(1,nall);
    fitA = 0;
    fitfitD = cell(1,nall);
    for n=1:nall,
        fitxpD{n} = cell(1,AllTracks{n}.ntracks);
        fitxpDprime{n} = cell(1,AllTracks{n}.ntracks);
        fitxpDbar{n} = cell(1,AllTracks{n}.ntracks);
        fitxpS{n} = cell(1,AllTracks{n}.ntracks);
        fitxpSprime{n} = cell(1,AllTracks{n}.ntracks);
        fitxpSbar{n} = cell(1,AllTracks{n}.ntracks);
        fitNt{n} = cell(1,AllTracks{n}.ntracks);
        fitbt{n} = cell(1,AllTracks{n}.ntracks);
        fitfitD{n} = cell(1,AllTracks{n}.ntracks);
        for t=1:AllTracks{n}.ntracks,
            fitxpD{n}{t} = []; fitxpS{n}{t} = []; fitNt{n}{t} = 0; fitbt{n}{t} = 0;
            fitfitD{n}{t} = [];
            if inorexclude{n}(t),
                filter = AllTracks{n}.slopes(:,t) > AllTracks{n}.slopefitmin(t);
                fitxpS{n}{t} = AllTracks{n}.slopes(filter,t);
                fitxpD{n}{t} = AllTracks{n}.shifts(filter,t);
                fitNt{n}{t} = length(fitxpS{n}{t});
                fitxpSbar{n}{t} = mean(fitxpS{n}{t});
                fitxpDbar{n}{t} = mean(fitxpD{n}{t});
                fitxpSprime{n}{t} = fitxpS{n}{t}-fitxpSbar{n}{t};
                fitxpDprime{n}{t} = fitxpD{n}{t}-fitxpDbar{n}{t};
            end;
        end;
    end;
    sumDS = 0; sumSS = 0;
    for n=1:nall,
        for t=1:AllTracks{n}.ntracks,
            if inorexclude{n}(t),
                sumDS = sumDS + sum(fitxpDprime{n}{t}.*fitxpSprime{n}{t});
                sumSS = sumSS + sum(fitxpSprime{n}{t}.*fitxpSprime{n}{t});
            end;
        end;
    end;
    fitA = sumDS/sumSS;
    for n=1:nall,
        for t=1:AllTracks{n}.ntracks,
            if inorexclude{n}(t),
                fitbt{n}{t} = fitxpDbar{n}{t} - fitA*fitxpSbar{n}{t};
                fitfitD{n}{t} = fitbt{n}{t} + fitA*fitxpS{n}{t};
            end;
        end;
    end;
    
    isfitted = 1;
end;

%% plot one by one
if isfitted,
    countt = 0;
    for n=1:nall,
        for t=1:AllTracks{n}.ntracks,
            countt = countt + 1;
            if inorexclude{n}(t),
                heachfig(countt) = figure('Name',[AllTracks{n}.filename '-' num2str(t)],'NumberTitle','off'); clf;
                set(gcf,'PaperOrientation','portrait');
                set(gcf,'PaperPositionMode','manual');
                set(gcf,'Units','inches');
                set(gcf,'PaperUnits','inches');
                set(gcf,'Position',[1 0.5 6.5 4.5]);%on screen, but also on paper?
                set(gcf,'PaperPosition', [1 0.5 6.5 4.5]);
                subplot('Position',[0.15 0.15 0.8 0.75]);hold on;
                set(gca,'FontSize',11);
                set(gca,'FontName','Times');
                set(gca,'Box', 'on');
                %                 xborder = 0.05; yborder = 0.02;
                hold on;
                filter = AllTracks{n}.slopes(:,t) > AllTracks{n}.slopefitmin(t);
                plot(AllTracks{n}.slopes(:,t),AllTracks{n}.shifts(:,t),'o','LineWidth',0.25,'Color','k');
                plot(AllTracks{n}.slopes(filter,t),AllTracks{n}.shifts(filter,t),'o','LineWidth',0.25,'MarkerFaceColor','k');
                plot(fitxpS{n}{t},fitfitD{n}{t},'-','LineWidth',1,'Color','k');
                title([AllTracks{n}.filename '-' num2str(t) '@' num2str(AllTracks{n}.radii(t))]);
                ylabel('displacement (cm)','FontSize',14);
                xlabel('signal slope (fringes/cm)','FontSize', 14);
                saveas(heachfig(countt),[cdir '\' analysistitle '-' num2str(countt) '.fig']);
                print(heachfig(countt),[cdir '\' analysistitle '-' num2str(countt) '.png'],'-dpng','-r300');
            end;
        end;
    end;
    
end;

%% close all figs
if isfitted,
    countt = 0;
    for n=1:nall,
        for t=1:AllTracks{n}.ntracks,
            countt = countt + 1;
            if inorexclude{n}(t),
                delete(heachfig(countt));
            end;
        end;
    end;
end;

%%  plot all
hall = figure('Name',analysistitle,'NumberTitle','off'); clf;
set(gcf,'PaperOrientation','portrait');
set(gcf,'PaperPositionMode','manual');
set(gcf,'Units','inches');
set(gcf,'PaperUnits','inches');
set(gcf,'Position',[1 0.5 6.5 4.5]);%on screen, but also on paper?
set(gcf,'PaperPosition', [1 0.5 6.5 4.5]);
%     set(gcf, 'color', 'white'); %this is the background
subplot('Position',[0.15 0.15 0.8 0.75]);hold on;
set(gca,'FontSize',11);
set(gca,'FontName','Times');
set(gca,'Box', 'on');
xborder = 0.05; yborder = 0.02;

hold on;
countt = 0;legendstr = [];
for n=1:nall,
    for t=1:AllTracks{n}.ntracks,
        countt = countt + 1;
        if inorexclude{n}(t),
            filter = AllTracks{n}.slopes(:,t) > AllTracks{n}.slopefitmin(t);
            plot(AllTracks{n}.slopes(:,t),AllTracks{n}.shifts(:,t),'o','LineWidth',0.25,'Color',CC(countt,:));
            %             plot(AllTracks{n}.slopes(filter,t),AllTracks{n}.shifts(filter,t),'o','LineWidth',0.25,'MarkerFaceColor',CC(countt,:));
            legendstr = [legendstr '''' [AllTracks{n}.filename '-' num2str(t) '@' num2str(AllTracks{n}.radii(t))] ''''];
            if countt < ntrackstot, legendstr = [legendstr ', ']; end;
        end;
    end;
end;
YL = ylim; countt = 0;
if isfitted,
    for n=1:nall,
        for t=1:AllTracks{n}.ntracks,
            countt = countt + 1;
            if inorexclude{n}(t),
                plot(fitxpS{n}{t},fitfitD{n}{t},'-','LineWidth',1,'Color',CC(countt,:));
            end;
        end;
    end;
else
    for n=1:nall,
        for t=1:AllTracks{n}.ntracks,
            countt = countt + 1;
            if inorexclude{n}(t),
                plot(AllTracks{n}.slopefitmin(t)*[1 1],0.9*YL,':','LineWidth',0.75,'Color',CC(countt,:));
            end;
        end;
    end;
end;

eval (['hleg = legend (' legendstr ',''Location'',''SouthEast'');']);
set(hleg,'FontSize',6); legend('boxoff');

countt = 0;
for n=1:nall,
    for t=1:AllTracks{n}.ntracks,
        countt = countt + 1;
        if inorexclude{n}(t),
            filter = AllTracks{n}.slopes(:,t) > AllTracks{n}.slopefitmin(t);
            %             plot(AllTracks{n}.slopes(:,t),AllTracks{n}.shifts(:,t),'o','LineWidth',0.25,'Color',CC(countt,:));
            plot(AllTracks{n}.slopes(filter,t),AllTracks{n}.shifts(filter,t),'o','LineWidth',0.25,'MarkerFaceColor',CC(countt,:));
        end;
    end;
end;

if isfitted,
    title(['best-fit shift/slope = ' num2str(fitA)]);
end;
ylabel('displacement (cm)','FontSize',14);
xlabel('signal slope (fringes/cm)','FontSize', 14);
saveas(hall,[cdir '\' analysistitle '.fig']);
print(hall,[cdir '\' analysistitle '.png'],'-dpng','-r300');


save(savefilename);





